org.optaplanner.core.api.score.buildin.simpledouble

## Class SimpleDoubleScoreHolder

- java.lang.Object
- - org.optaplanner.core.api.score.holder.AbstractScoreHolder<SimpleDoubleScore>
  - - org.optaplanner.core.api.score.buildin.simpledouble.SimpleDoubleScoreHolder

- All Implemented Interfaces:
    Serializable, ScoreHolder<SimpleDoubleScore>

  Deprecated.
  Double-based scores are deprecated as floating point numbers are not associative (A + B + C == C + B + A) and therefore they are not compatible with incremental score calculation. Use `SimpleBigDecimalScoreHolder` or a scaled `SimpleLongScoreHolder` instead.

      @Deprecated
      public class SimpleDoubleScoreHolder
      extends AbstractScoreHolder<SimpleDoubleScore>

  WARNING: NOT RECOMMENDED TO USE DUE TO ROUNDING ERRORS THAT CAUSE SCORE CORRUPTION. Use `SimpleBigDecimalScoreHolder` instead.
  See Also:
    `SimpleDoubleScore`, Serialized Form

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class org.optaplanner.core.api.score.holder.AbstractScoreHolder

      `AbstractScoreHolder.ConstraintActivationUnMatchListener`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected Map<org.kie.api.definition.rule.Rule,BiConsumer<org.kie.api.runtime.rule.RuleContext,Double>>` | `matchExecutorByNumberMap` Deprecated.
    `protected double` | `score` Deprecated.

    - ### Fields inherited from class org.optaplanner.core.api.score.holder.AbstractScoreHolder

      `constraintMatchEnabled, constraintMatchTotalMap, indictmentMap, zeroScore`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `SimpleDoubleScoreHolder(boolean constraintMatchEnabled)` Deprecated.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods Deprecated Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `addConstraintMatch(org.kie.api.runtime.rule.RuleContext kcontext, double weight)` Deprecated.
    `void` | `configureConstraintWeight(org.kie.api.definition.rule.Rule rule, SimpleDoubleScore constraintWeight)` Deprecated. Sets up a `ConstraintWeight` from the `ConstraintConfiguration` during initialization.
    `SimpleDoubleScore` | `extractScore(int initScore)` Deprecated. Extracts the `Score`, calculated by the `KieSession` for `DroolsScoreDirector`.
    `double` | `getScore()` Deprecated.
    `void` | `impactScore(org.kie.api.runtime.rule.RuleContext kcontext)` Deprecated. For internal use only, use penalize() or reward() instead.
    `void` | `penalize(org.kie.api.runtime.rule.RuleContext kcontext)` Deprecated. Penalize a match by the `ConstraintWeight` negated.
    `void` | `penalize(org.kie.api.runtime.rule.RuleContext kcontext, double weightMultiplier)` Deprecated. Penalize a match by the `ConstraintWeight` negated and multiplied with the weightMultiplier for all score levels.
    `void` | `reward(org.kie.api.runtime.rule.RuleContext kcontext)` Deprecated. Reward a match by the `ConstraintWeight`.
    `void` | `reward(org.kie.api.runtime.rule.RuleContext kcontext, double weightMultiplier)` Deprecated. Reward a match by the `ConstraintWeight` multiplied with the weightMultiplier for all score levels.

    - ### Methods inherited from class org.optaplanner.core.api.score.holder.AbstractScoreHolder

      `extractJustificationList, getConstraintMatchTotalMap, getConstraintMatchTotals, getIndictmentMap, impactScore, impactScore, impactScore, isConstraintMatchEnabled, registerConstraintMatch, setJustificationListConverter`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### matchExecutorByNumberMap

          protected final Map<org.kie.api.definition.rule.Rule,BiConsumer<org.kie.api.runtime.rule.RuleContext,Double>> matchExecutorByNumberMap

      Deprecated.

    - #### score

          protected double score

      Deprecated.

  - ### Constructor Detail

    - #### SimpleDoubleScoreHolder

          public SimpleDoubleScoreHolder(boolean constraintMatchEnabled)

      Deprecated.

  - ### Method Detail

    - #### getScore

          public double getScore()

      Deprecated.

    - #### configureConstraintWeight

          public void configureConstraintWeight(org.kie.api.definition.rule.Rule rule,
                                                SimpleDoubleScore constraintWeight)

      Deprecated.
      Description copied from interface: `ScoreHolder`
      Sets up a `ConstraintWeight` from the `ConstraintConfiguration` during initialization.
      Specified by:
        `configureConstraintWeight` in interface `ScoreHolder<SimpleDoubleScore>`
      Overrides:
        `configureConstraintWeight` in class `AbstractScoreHolder<SimpleDoubleScore>`
      Parameters:
        `rule` - never null
        `constraintWeight` - never null, with `Score.getInitScore()` equal to 0.

    - #### penalize

          public void penalize(org.kie.api.runtime.rule.RuleContext kcontext)

      Deprecated.
      Penalize a match by the `ConstraintWeight` negated.
      Parameters:
        `kcontext` - never null, the magic variable in DRL

    - #### penalize

          public void penalize(org.kie.api.runtime.rule.RuleContext kcontext,
                               double weightMultiplier)

      Deprecated.
      Penalize a match by the `ConstraintWeight` negated and multiplied with the weightMultiplier for all score levels.
      Parameters:
        `kcontext` - never null, the magic variable in DRL
        `weightMultiplier` - at least 0

    - #### reward

          public void reward(org.kie.api.runtime.rule.RuleContext kcontext)

      Deprecated.
      Reward a match by the `ConstraintWeight`.
      Parameters:
        `kcontext` - never null, the magic variable in DRL

    - #### reward

          public void reward(org.kie.api.runtime.rule.RuleContext kcontext,
                             double weightMultiplier)

      Deprecated.
      Reward a match by the `ConstraintWeight` multiplied with the weightMultiplier for all score levels.
      Parameters:
        `kcontext` - never null, the magic variable in DRL
        `weightMultiplier` - at least 0

    - #### impactScore

          public void impactScore(org.kie.api.runtime.rule.RuleContext kcontext)

      Deprecated.
      Description copied from class: `AbstractScoreHolder`
      For internal use only, use penalize() or reward() instead.
      Overrides:
        `impactScore` in class `AbstractScoreHolder<SimpleDoubleScore>`
      Parameters:
        `kcontext` - never null

    - #### addConstraintMatch

          public void addConstraintMatch(org.kie.api.runtime.rule.RuleContext kcontext,
                                         double weight)

      Deprecated.
      Parameters:
        `kcontext` - never null, the magic variable in DRL
        `weight` - higher is better, negative for a penalty, positive for a reward

    - #### extractScore

          public SimpleDoubleScore extractScore(int initScore)

      Deprecated.
      Description copied from interface: `ScoreHolder`
      Extracts the `Score`, calculated by the `KieSession` for `DroolsScoreDirector`.

      Should not be called directly, use `ScoreDirector.calculateScore()` instead.

      Parameters:
        `initScore` - `<= 0`, managed by OptaPlanner, needed as a parameter in the `Score`'s creation method, see `Score.getInitScore()`
      Returns:
        never null, the `Score` of the working `PlanningSolution`

Copyright © 2006–2021 JBoss by Red Hat. All rights reserved.